
/* 
This EA is a time based stop loss.
EA's purpose is to close % of a position after specified time has elapsed of a losing position.
There are four time based levels and you can choose to close specified position % at these time levels.


*/


extern string  Select_Criteria="---- Time Based Stop Loss ----";
extern bool    UseTimeBasedStopLoss    = TRUE;

extern string  Precent_Close="% of positon to close at each time inverval of a losing trade, <=100%";
extern double  PercentClose1       = 25;//position percent to close
extern double  PercentClose2       = 50;//position percent to close
extern double  PercentClose3       = 75;//position percent to close
extern double  PercentClose4       = 100;//position percent to close

extern string  Loss_Time="Seconds: For each invervals how many seconds to wait before losing trade is closed"; 
extern double  TimeBasedSLperiodLoss1   = 10; // in seconds
extern double  TimeBasedSLperiodLoss2   = 30;
extern double  TimeBasedSLperiodLoss3   = 60;
extern double  TimeBasedSLperiodLoss4   = 75;


int init() {
 
 return(0);
}

int deinit() {
 return(0);
}

int start() {
 if (UseTimeBasedStopLoss) TimeBasedSL(Symbol(),TimeBasedSLperiodLoss1,TimeBasedSLperiodLoss2,TimeBasedSLperiodLoss3, TimeBasedSLperiodLoss4);

}

void TimeBasedSL(string symbol,double TimeBasedSLperiodLoss1,double TimeBasedSLperiodLoss2,double TimeBasedSLperiodLoss3,double TimeBasedSLperiodLoss4) {
 bool result;
 double TimeBasedSL=0.0;
 

 string sTimeBasedSLperiod;
 
   int totalopenorders=0;
   for (int cnt=OrdersTotal()-1; cnt>=0; cnt--) 
   {
      if (!OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES)) continue;
      if (OrderSymbol()!=symbol)                       continue;
      totalopenorders++;
      double profit   = OrderProfit()+OrderCommission()+OrderSwap();
      double  minLot  = MarketInfo(Symbol(), MODE_MINLOT),
              lotStep = MarketInfo(Symbol(), MODE_LOTSTEP),
              Lots    = OrderLots();
    
     bool alreadyExecuted1 = false;
     bool alreadyExecuted2 = false;
     bool alreadyExecuted3 = false;
     bool alreadyExecuted4 = false;

// BELOW IS WHERE I DO NOT KNOW HOW TO CODE PROPERLY. LOSING TRADES ARE NOT CLOSING TRADES ON SPCIFIED TIMES AND SPECIFIED PERCENT. ANY HELP?
    
    if (profit<=0.0) 
    {
       if(alreadyExecuted1=false) 
       {
         if ((TimeCurrent() - OrderOpenTime()) >= TimeBasedSLperiodLoss1) 
         {
            alreadyExecuted1 = true;
            if (OrderType()==OP_BUY) 
            {//buy
               result=OrderClose(OrderTicket(),MathFloor(Lots*(PercentClose1/100)/lotStep)*lotStep,MarketInfo(OrderSymbol(),MODE_BID),9999,CLR_NONE);
               Print("TimeBasedSL(): **** BUY order ticket TimeBasedSLperiodLoss1 "+OrderTicket()+" (opentime: "+TimeToStr(OrderOpenTime())+") "+sTimeBasedSLperiod+" of "+DoubleToStr(profit,2)+" "+AccountCurrency());
            }
            if (OrderType()==OP_SELL) 
            {//sell
               result=OrderClose(OrderTicket(),MathFloor(Lots*(PercentClose1/100)/lotStep)*lotStep,MarketInfo(OrderSymbol(),MODE_ASK),9999,CLR_NONE);
               Print("TimeBasedSL(): **** SELL order ticket TimeBasedSLperiodLoss1 "+OrderTicket()+" (opentime: "+TimeToStr(OrderOpenTime())+") "+sTimeBasedSLperiod+" of "+DoubleToStr(profit,2)+" "+AccountCurrency());
            }
         }            
      }
      if(!alreadyExecuted2) 
      {
         if ((TimeCurrent() - OrderOpenTime()) >= TimeBasedSLperiodLoss2) 
         {
            alreadyExecuted2 = true;
            if (OrderType()==OP_BUY) 
            {//buy
                  result=OrderClose(OrderTicket(),MathFloor(Lots*(PercentClose2/100)/lotStep)*lotStep,MarketInfo(OrderSymbol(),MODE_BID),9999,CLR_NONE);
                  Print("TimeBasedSL(): **** BUY order ticket TimeBasedSLperiodLoss2 "+OrderTicket()+" (opentime: "+TimeToStr(OrderOpenTime())+") "+sTimeBasedSLperiod+" of "+DoubleToStr(profit,2)+" "+AccountCurrency());
            }
            if (OrderType()==OP_SELL) 
            {//sell
               result=OrderClose(OrderTicket(),MathFloor(Lots*(PercentClose2/100)/lotStep)*lotStep,MarketInfo(OrderSymbol(),MODE_ASK),9999,CLR_NONE);
               Print("TimeBasedSL(): **** SELL order ticket TimeBasedSLperiodLoss2 "+OrderTicket()+" (opentime: "+TimeToStr(OrderOpenTime())+") "+sTimeBasedSLperiod+" of "+DoubleToStr(profit,2)+" "+AccountCurrency());
            }
         }
      }         
      if(!alreadyExecuted3) 
      {
         if ((TimeCurrent() - OrderOpenTime()) >= TimeBasedSLperiodLoss3) 
         {
            alreadyExecuted3 = true;
            if (OrderType()==OP_BUY) 
            {//buy
               result=OrderClose(OrderTicket(),MathFloor(Lots*(PercentClose3/100)/lotStep)*lotStep,MarketInfo(OrderSymbol(),MODE_BID),9999,CLR_NONE);
               Print("TimeBasedSL(): **** BUY order ticket TimeBasedSLperiodLoss3 "+OrderTicket()+" (opentime: "+TimeToStr(OrderOpenTime())+") "+sTimeBasedSLperiod+" of "+DoubleToStr(profit,2)+" "+AccountCurrency());
            }
            if (OrderType()==OP_SELL) 
            {//sell
               result=OrderClose(OrderTicket(),MathFloor(Lots*(PercentClose3/100)/lotStep)*lotStep,MarketInfo(OrderSymbol(),MODE_ASK),9999,CLR_NONE);
               Print("TimeBasedSL(): **** SELL order ticket TimeBasedSLperiodLoss3 "+OrderTicket()+" (opentime: "+TimeToStr(OrderOpenTime())+") "+sTimeBasedSLperiod+" of "+DoubleToStr(profit,2)+" "+AccountCurrency());
            }
         }
      }
      if(!alreadyExecuted4) 
      {
         if ((TimeCurrent() - OrderOpenTime()) >= TimeBasedSLperiodLoss4) 
         {
            alreadyExecuted4 = true;
            if (OrderType()==OP_BUY) 
            {//buy
               result=OrderClose(OrderTicket(),MathFloor(Lots*(PercentClose4/100)/lotStep)*lotStep,MarketInfo(OrderSymbol(),MODE_BID),9999,CLR_NONE);
               Print("TimeBasedSL(): **** BUY order ticket TimeBasedSLperiodLoss4 "+OrderTicket()+" (opentime: "+TimeToStr(OrderOpenTime())+") "+sTimeBasedSLperiod+" of "+DoubleToStr(profit,2)+" "+AccountCurrency());
            }
            if (OrderType()==OP_SELL) 
            {//sell
               result=OrderClose(OrderTicket(),MathFloor(Lots*(PercentClose4/100)/lotStep)*lotStep,MarketInfo(OrderSymbol(),MODE_ASK),9999,CLR_NONE);
               Print("TimeBasedSL(): **** SELL order ticket TimeBasedSLperiodLoss4 "+OrderTicket()+" (opentime: "+TimeToStr(OrderOpenTime())+") "+sTimeBasedSLperiod+" of "+DoubleToStr(profit,2)+" "+AccountCurrency());
            }
         }
      }
      }
   }   
}

